(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'draft-js-plugins-editor', 'draft-js-emoji-plugin', 'draft-js-entity-props-plugin', 'draft-js-hashtag-plugin', 'draft-js-linkify-plugin', 'draft-js-table-plugin', 'draft-js-toolbar-plugin', 'draft-js', './Sidebar', './Media'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('draft-js-plugins-editor'), require('draft-js-emoji-plugin'), require('draft-js-entity-props-plugin'), require('draft-js-hashtag-plugin'), require('draft-js-linkify-plugin'), require('draft-js-table-plugin'), require('draft-js-toolbar-plugin'), require('draft-js'), require('./Sidebar'), require('./Media'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.draftJsPluginsEditor, global.draftJsEmojiPlugin, global.draftJsEntityPropsPlugin, global.draftJsHashtagPlugin, global.draftJsLinkifyPlugin, global.draftJsTablePlugin, global.draftJsToolbarPlugin, global.draftJs, global.Sidebar, global.Media);
    global.RichTextEditor = mod.exports;
  }
})(this, function (exports, _react, _draftJsPluginsEditor, _draftJsEmojiPlugin, _draftJsEntityPropsPlugin, _draftJsHashtagPlugin, _draftJsLinkifyPlugin, _draftJsTablePlugin, _draftJsToolbarPlugin, _draftJs, _Sidebar, _Media) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _draftJsPluginsEditor2 = _interopRequireDefault(_draftJsPluginsEditor);

  var _draftJsEmojiPlugin2 = _interopRequireDefault(_draftJsEmojiPlugin);

  var _draftJsEntityPropsPlugin2 = _interopRequireDefault(_draftJsEntityPropsPlugin);

  var _draftJsHashtagPlugin2 = _interopRequireDefault(_draftJsHashtagPlugin);

  var _draftJsLinkifyPlugin2 = _interopRequireDefault(_draftJsLinkifyPlugin);

  var _draftJsTablePlugin2 = _interopRequireDefault(_draftJsTablePlugin);

  var _draftJsToolbarPlugin2 = _interopRequireDefault(_draftJsToolbarPlugin);

  var _Sidebar2 = _interopRequireDefault(_Sidebar);

  var _Media2 = _interopRequireDefault(_Media);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  var emojiPlugin = (0, _draftJsEmojiPlugin2.default)();
  var EmojiSuggestions = emojiPlugin.EmojiSuggestions;

  var entityPlugin = (0, _draftJsEntityPropsPlugin2.default)();
  var hashtagPlugin = (0, _draftJsHashtagPlugin2.default)();
  var linkifyPlugin = (0, _draftJsLinkifyPlugin2.default)({
    target: '_blank' // default is '_self'
  });
  var toolbarPlugin = (0, _draftJsToolbarPlugin2.default)({
    __toolbarHandler: {
      add: function add(props) {
        return console.log('Add toolbar', props);
      },
      remove: function remove(props) {
        return console.log('Remove toolbar', props);
      }
    }, textActions: [{
      button: _react2.default.createElement(
        'span',
        null,
        'code'
      ),
      key: 'in-code',
      label: 'Inline code',
      active: function active(block, editorState) {
        return block.get('type') === 'CODE';
      },
      toggle: function toggle(block, action, editorState, setEditorState) {
        return setEditorState(_draftJs.RichUtils.toggleInlineStyle(editorState, 'CODE'));
      }
    }, {
      button: _react2.default.createElement(
        'span',
        null,
        'H1'
      ),
      key: 'H1',
      label: 'Header 1',
      active: function active(block, editorState) {
        return block.get('type') === 'header-one';
      },
      toggle: function toggle(block, action, editorState, setEditorState) {
        return setEditorState(_draftJs.RichUtils.toggleBlockType(editorState, 'header-one'));
      }
    }, {
      button: _react2.default.createElement(
        'span',
        null,
        'H2'
      ),
      key: 'H2',
      label: 'Header 2',
      active: function active(block, editorState) {
        return block.get('type') === 'header-two';
      },
      toggle: function toggle(block, action, editorState, setEditorState) {
        return setEditorState(_draftJs.RichUtils.toggleBlockType(editorState, 'header-two'));
      }
    }, {
      button: _react2.default.createElement(
        'span',
        null,
        'H3'
      ),
      key: 'H3',
      label: 'Header 3',
      active: function active(block, editorState) {
        return block.get('type') === 'header-three';
      },
      toggle: function toggle(block, action, editorState, setEditorState) {
        return setEditorState(_draftJs.RichUtils.toggleBlockType(editorState, 'header-three'));
      }
    }, {
      button: _react2.default.createElement(
        'span',
        null,
        'H4'
      ),
      key: 'H4',
      label: 'Header 4',
      active: function active(block, editorState) {
        return block.get('type') === 'header-four';
      },
      toggle: function toggle(block, action, editorState, setEditorState) {
        return setEditorState(_draftJs.RichUtils.toggleBlockType(editorState, 'header-four'));
      }
    }, {
      button: _react2.default.createElement(
        'span',
        null,
        'H5'
      ),
      key: 'H5',
      label: 'Header 5',
      active: function active(block, editorState) {
        return block.get('type') === 'header-five';
      },
      toggle: function toggle(block, action, editorState, setEditorState) {
        return setEditorState(_draftJs.RichUtils.toggleBlockType(editorState, 'header-five'));
      }
    }, {
      button: _react2.default.createElement(
        'span',
        null,
        'quote'
      ),
      key: 'quote',
      label: 'Blockquote',
      active: function active(block, editorState) {
        return block.get('type') === 'blockquote';
      },
      toggle: function toggle(block, action, editorState, setEditorState) {
        return setEditorState(_draftJs.RichUtils.toggleBlockType(editorState, 'blockquote'));
      }
    }, {
      button: _react2.default.createElement(
        'span',
        null,
        'list'
      ),
      key: 'u-list',
      label: 'Unordered list',
      active: function active(block, editorState) {
        return block.get('type') === 'unordered-list-item';
      },
      toggle: function toggle(block, action, editorState, setEditorState) {
        return setEditorState(_draftJs.RichUtils.toggleBlockType(editorState, 'unordered-list-item'));
      }
    }, {
      button: _react2.default.createElement(
        'span',
        null,
        'list'
      ),
      key: 'o-list',
      label: 'Ordered list',
      active: function active(block, editorState) {
        return block.get('type') === 'ordered-list-item';
      },
      toggle: function toggle(block, action, editorState, setEditorState) {
        return setEditorState(_draftJs.RichUtils.toggleBlockType(editorState, 'ordered-list-item'));
      }
    }, {
      button: _react2.default.createElement(
        'span',
        null,
        'code'
      ),
      key: 'code',
      label: 'Code block',
      active: function active(block, editorState) {
        return block.get('type') === 'code-block';
      },
      toggle: function toggle(block, action, editorState, setEditorState) {
        return setEditorState(_draftJs.RichUtils.toggleBlockType(editorState, 'code-block'));
      }
    }]
  });
  var tablePlugin = (0, _draftJsTablePlugin2.default)({
    Editor: _draftJsPluginsEditor2.default
  });

  var tableCreator = tablePlugin.tableCreator;


  var plugins = [emojiPlugin, entityPlugin, hashtagPlugin, linkifyPlugin, tablePlugin, toolbarPlugin];

  var RichTextEditor = function (_React$Component) {
    _inherits(RichTextEditor, _React$Component);

    function RichTextEditor(props) {
      _classCallCheck(this, RichTextEditor);

      var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(RichTextEditor).call(this, props));

      if (_this.props.content) {
        var contentState = stateFromMarkdown(_this.props.content);

        _this.state = {
          editorState: _draftJs.EditorState.createWithContent(contentState)
        };
      } else {
        _this.state = {
          editorState: _draftJs.EditorState.createEmpty()
        };
      }

      _this.focus = function () {
        return _this.refs.editor.focus();
      };
      _this.onChange = function (editorState) {
        return _this.setState({ editorState: editorState });
      };
      _this.handleKeyCommand = _this.handleKeyCommand.bind(_this);

      _this.convertToRaw = function () {
        var editorState = _this.state.editorState;

        var contentState = editorState.getCurrentContent();
        return (0, _draftJs.convertToRaw)(contentState);
      };
      return _this;
    }

    _createClass(RichTextEditor, [{
      key: 'handleKeyCommand',
      value: function handleKeyCommand(command) {
        var editorState = this.state.editorState;

        var newState = _draftJs.RichUtils.handleKeyCommand(editorState, command);
        if (newState) {
          this.onChange(newState);
          return true;
        }
        return false;
      }
    }, {
      key: 'blockRenderer',
      value: function blockRenderer(block) {
        if (block.getType() === 'atomic') {
          return { component: _Media2.default, editable: false };
        }
        return null;
      }
    }, {
      key: 'render',
      value: function render() {
        var editorState = this.state.editorState;
        var filePickerKey = this.props.filePickerKey;


        return _react2.default.createElement(
          'div',
          { id: 'rich-text-editor', className: 'callout' },
          _react2.default.createElement(_Sidebar2.default, {
            onChange: this.onChange,
            filePickerKey: filePickerKey,
            editorState: editorState
          }),
          _react2.default.createElement(
            'div',
            {
              style: { marginLeft: '50px', minHeight: '50vh' },
              onClick: this.focus
            },
            _react2.default.createElement(_draftJsPluginsEditor2.default, {
              blockRendererFn: this.blockRenderer,
              editorState: editorState,
              handleKeyCommand: this.handleKeyCommand,
              onChange: this.onChange,
              placeholder: 'Tell a story...',
              ref: 'editor',
              plugins: plugins,
              spellCheck: true
            }),
            _react2.default.createElement('tableCreator', null),
            _react2.default.createElement(EmojiSuggestions, null)
          )
        );
      }
    }]);

    return RichTextEditor;
  }(_react2.default.Component);

  RichTextEditor.props = {
    filePickerKey: _react.PropTypes.string.isRequired
  };

  exports.default = RichTextEditor;
});