import React from 'react';
import { Entity } from 'draft-js';
import Audio from './Audio.jsx';
import Image from './Image.jsx';
import Video from './Video.jsx';

const Media = ({ block }) => {
  const entity = Entity.get(block.getEntityAt(0));
  const { src } = entity.getData();
  const type = entity.getType();

  let media;
  if (type === 'AUDIO') {
    media = <Audio src={src} />;
  } else if (type === 'IMAGE') {
    media = <Image src={src} />;
  } else if (type === 'VIDEO') {
    media = <Video src={src} />;
  }

  return media;
};

export default Media;
